# Contributing to the IBM Fully Homomorphic Toolkit for MacOS

Adding new features, improving documentation, fixing bugs, or writing tutorials are all examples of helpful contributions. 
We kindly request that any bug fixes be initiated through GitHub pull requests (PRs). 

When making code contributions to IBM Fully Homomorphic Toolkit for MacOS, we ask that you follow the C++ coding conventions consistent with the rest of the project. We also ask that contributions of new code for features come complete with unit tests for those new features. Once all the tests have passed, and you are satisfied with your contribution, open a pull request into the `master` branch from **your fork of the repository** to request adding your contributions into the main code base.


This project uses [DCO](https://developercertificate.org/). 
Be sure to sign off your commits using the `-s` flag or adding `Signed-off-By: Name<Email>` in the commit message.

### Example commit message
```bash
git commit -s -m 'Informative commit message'
```


